package com.gingersoft.gsa.cloud.table.mvp.contract;

import com.gingersoft.gsa.cloud.base.common.bean.BaseResult;
import com.gingersoft.gsa.cloud.base.common.bean.BaseResultOld;
import com.gingersoft.gsa.cloud.base.table.bean.TableBean;
import com.gingersoft.gsa.cloud.table.mvp.model.bean.BaseOrderRespose;
import com.gingersoft.gsa.cloud.table.mvp.model.bean.TableDetail;
import com.gingersoft.gsa.cloud.table.mvp.model.table.action.TableAction;
import com.gingersoft.gsa.cloud.table.mvp.ui.fragment.AllTableFragment;
import com.gingersoft.gsa.cloud.database.bean.Food;
import com.gingersoft.gsa.cloud.database.bean.Modifier;
import com.jess.arms.base.DefaultAdapter;
import com.jess.arms.mvp.IModel;
import com.jess.arms.mvp.IView;

import java.util.List;

import io.reactivex.Observable;
import okhttp3.RequestBody;
import retrofit2.http.Body;


/**
 * ================================================
 * Description:
 * <p>
 * Created by MVPArmsTemplate on 12/27/2019 19:19
 * <a href="mailto:jess.yan.effort@gmail.com">Contact me</a>
 * <a href="https://github.com/JessYanCoding">Follow me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms">Star me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms/wiki">See me</a>
 * <a href="https://github.com/JessYanCoding/MVPArmsTemplate">模版请保持更新</a>
 * ================================================
 */
public interface TableContract {
    //对于经常使用的关于UI的方法可以定义到IView中,如显示隐藏进度条,和显示文字消息
    interface View extends IView {

        void loadState(Class<?> c);

        void returnTableList(List<TableBean.DataBean> dataBeanList);

        void returnSplitTableList(List<TableBean.DataBean> dataBeanList);

        AllTableFragment getCurrentTableFragment();

        void clickTableItem(TableBean.DataBean dataBean);

        void onStartRefreshTableData();

        void onPauseRefreshTableData();

        void setBottomFunctionAdapter(DefaultAdapter adapter);

        void setBottomFunctionRecycleLayoutManager(int orientation);

        void setCurrentTableAction(TableAction action);

        void setTableActionContentText(String contentText);

        String getOperatContentText();

        void setTableActionTitle(TableAction action);

        void canceTableAction();

        void startMealStandActivity();

        void setBottomFunctionVisibility(boolean show);

        void setLockVisibility(boolean show);
    }

    //Model层定义接口,外部只需关心Model返回的数据,无需关心内部细节,即是否使用缓存
    interface Model extends IModel {

        List<Food> queryDB_AllFoodList();

        List<Modifier> queryDB_ModifierList(long fid, int mode);

        Observable<TableBean> getTables(int restaurantId);

        Observable<TableDetail> getTable(int tableId,String tableNumber);

        Observable<BaseOrderRespose> getOrderById(long orderId);

        Observable<BaseOrderRespose> openTable(RequestBody requestBody);

        Observable<BaseOrderRespose> turnTable(RequestBody requestBody);

        Observable<BaseOrderRespose> initTable(RequestBody requestBody);

        Observable<BaseResult> getSplitTables(int tableId);

        Observable<BaseResult> splitTable(int tableId);

        Observable<BaseResult> getFoodSummarys(int restaurantId,boolean isDefault, byte businessType);

        Observable<BaseResultOld> addScan(RequestBody requestBody);
    }
}
